/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Pais;
import com.rjconsultores.ventaboletos.service.PaisService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import java.util.Calendar;
import java.util.List;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Textbox;

/**
 *
 * @author Rafius
 */
@Controller("editarPaisController")
@Scope("prototype")
public class EditarPaisController extends MyGenericForwardComposer {

    @Autowired
    private PaisService paisService;
    private Pais pais;
    private MyListbox paisList;
    private Button btnApagar;
    private Button btnSalvar;
    private BusquedaPaisController busquedaPaisController;
    private static Logger log = Logger.getLogger(EditarPaisController.class);
    private MyTextbox txtNome;

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Textbox getTxtNome() {
        return txtNome;
    }

    public void setTxtNome(MyTextbox txtNome) {
        this.txtNome = txtNome;
    }

    public Button getBtnSalvar() {
        return btnSalvar;
    }

    public void setBtnSalvar(Button btnSalvar) {
        this.btnSalvar = btnSalvar;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);
        busquedaPaisController = (BusquedaPaisController) Executions.getCurrent().getArg().get("busquedaPaisController");
        pais = (Pais) Executions.getCurrent().getArg().get("pais");
        paisList = (MyListbox) Executions.getCurrent().getArg().get("paisList");

        if (pais.getPaisId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }
//        else {
//            if (pais.getPaisId() <= 2) {
//                btnApagar.setVisible(Boolean.FALSE);
//                btnSalvar.setVisible(Boolean.FALSE);
//                txtNome.setDisabled(Boolean.TRUE);
//
//                Messagebox.show(
//                        Labels.getLabel("MSG.noEditabled"),
//                        Labels.getLabel("editarPaisController.window.title"),
//                        Messagebox.OK, Messagebox.INFORMATION);
//            }
//        }

        txtNome.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {
        txtNome.getValue();
        try {
            pais.setActivo(true);
            pais.setFecmodif(Calendar.getInstance().getTime());
            pais.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());


            boolean podeSalvar = false;
            List<Pais> lsPais = paisService.buscar(pais.getNombpais());
            if (lsPais.isEmpty()) {
                podeSalvar = true;
            } else {
                if (pais.getPaisId() != null) {
                    for (Pais p : lsPais) {
                        if (p.getPaisId().equals(pais.getPaisId())) {
                            podeSalvar = true;
                        }
                    }
                }
            }

            if (podeSalvar) {
                if (pais.getPaisId() == null) {
                    paisService.suscribir(pais);
                    paisList.addItem(pais);
                } else {
                    paisService.actualizacion(pais);
                    paisList.updateItem(pais);
                }
                Messagebox.show(
                        Labels.getLabel("editarPaisController.MSG.suscribirOK"),
                        Labels.getLabel("editarPaisController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
                busquedaPaisController.refreshLista();
                closeWindow();

            } else {
                Messagebox.show(
                        Labels.getLabel("MSG.Registro.Existe"),
                        Labels.getLabel("editarPaisController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            }

        } catch (Exception ex) {
            log.error("editarPaisController: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarPaisController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }
    }

    public void onClick$btnApagar(Event ev) {
        try {
            int resp = Messagebox.show(
                    Labels.getLabel("editarPaisController.MSG.borrarPergunta"),
                    Labels.getLabel("editarPaisController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (resp == Messagebox.YES) {

                paisService.borrar(pais);

                Messagebox.show(
                        Labels.getLabel("editarPaisController.MSG.borrarOK"),
                        Labels.getLabel("editarPaisController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                paisList.removeItem(pais);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }

    public Pais getPais() {
        return pais;
    }

    public void setPais(Pais pais) {
        this.pais = pais;
    }

    public MyListbox getPaisList() {
        return paisList;
    }

    public void setPaisList(MyListbox paisList) {
        this.paisList = paisList;
    }

    public PaisService getPaisService() {
        return paisService;
    }

    public void setPaisService(PaisService paisService) {
        this.paisService = paisService;
    }
}
